version 8.2
clear
set logtype text
set more off
set matsize 200

capture log close
log using "brazrloc/logs/rais-cnpj-data-metro.log", replace

foreach ext in a b c d e f g h i j {
  tempfile plnt_`ext'
  use identificad ano n_pis indprim indhigh indprof indtech indwhit using "rais/base-agg/cnpj/aggcnpj_`ext'", clear
  gen indwhittot = indprof + indtech + indwhit
  label var indwhittot "Share: White-collar occup."
  drop indprof indtech indwhit
  merge identificad ano using "brazrloc/data/rais-cnpj-list-metro"
  tab _m
  keep if _m==3
  sort identificad ano
  save `plnt_`ext''
  }

use `plnt_a'
foreach ext in b c d e f g h i j {
  append using `plnt_`ext''
  }

keep identificad ano n_pis indprim indhigh indwhittot
order identificad ano n_pis indprim indhigh indwhittot
foreach var in n_pis indprim indhigh indwhittot {
  rename `var' plant_`var'
  }
sort identificad ano
save "brazrloc/data/rais-cnpj-data-metro", replace

log close
