version 8.2
clear
set logtype text
set more off
set matsize 200

capture log close
log using "brazrloc/logs/sector-list.log", replace

foreach mapsec in aggsec tradsec {
local mapabbr = subinstr("`mapsec'","sec","",.)

tempfile `mapsec'
insheet using "brazrloc/auxil/subsector-`mapsec'tor.csv", comma clear
rename subsetoribge subs_ibge
rename `mapsec'tor `mapsec'
sort subs_ibge
replace `mapabbr'desc = trim(`mapabbr'desc)
replace `mapabbr'desc = upper(substr(`mapabbr'desc,1,1)) + substr(`mapabbr'desc,2,.)
preserve
  keep `mapsec' `mapabbr'desc
  duplicates drop
  qui count
  forvalues i = 1/`r(N)' {
    local lblno = `mapsec'[`i']
    local lbltit = `mapabbr'desc[`i']
    label define `mapsec' `lblno' "`lbltit'", add
    }
  if "`mapsec'"=="aggsec"  label define aggsec 0 "Primary", modify
  else {
    label define tradsec 1 "CADV 1st quintile", modify
    label define tradsec 2 "CADV 2nd quintile", modify
    label define tradsec 3 "CADV 3rd quintile", modify
    label define tradsec 4 "CADV 4th quintile", modify
    label define tradsec 5 "CADV 5th quintile", modify
    }
  label define `mapsec' 9 "n/a", modify
  label values `mapsec' `mapsec'
  label save `mapsec' using "brazrloc/auxil/`mapsec'", replace
restore
do "brazrloc/auxil/`mapsec'.do"
label values `mapsec' `mapsec'
keep subs_ibge `mapsec'
sort subs_ibge
compress
save ``mapsec''

use subsector grandsector using "rais/cnae/cnae2subsibge", clear
duplicates drop
rename subsector subs_ibge
gen _subsdesc = subs_ibge
label var _subsdesc "Description"
do "rais/cnae/ibge.do"
label values _subsdesc ibge
format _subsdesc %50.0g
order subs_ibge _subsdesc
sort subs_ibge
merge subs_ibge using ``mapsec''
qui count if _m~=3
if `r(N)'>0  STOP
drop _m
list

label var `mapsec' "Aggregate Sector"
keep subs_ibge `mapsec'
do "rais/cnae/ibge.do"
label values subs_ibge ibge
sort subs_ibge
compress
save "brazrloc/auxil/subsibge2`mapsec'", replace

}

log close
